/*----------------------------------------------------------------------
    Transmit & Receive Data via UART2 Serial 
            Library For C Language

̃CúClTXM16C/26}CRp̕łD

2004/11/18
AUTHOR :  Makoto Katsukura (Matsuo Lab.)

2006/11/16
EDITOR :  Hyunjong Kim (Matsuo Lab.)
----------------------------------------------------------------------*/

/*

   Pragma Instructions                                             

*/
/* M16C/26p̃wb_[t@CCN[h*/
#include "sfr26.h"

#include "uart2.h"

/* 荞݊֐ݒ肷 */
/* vector table ւ̓o^YȂ悤ɁI */
#pragma	INTERRUPT	uart2traint
#pragma	INTERRUPT	uart2recint



/*

   Global variable

*/
unsigned char	buf2_tra[TRA2_SIZE];		/* Transmit data */
unsigned char	buf2_rec[REC2_SIZE];		/* Receive data */

unsigned char uart2_transmited=0;
unsigned char uart2_received=0;
unsigned char uart2_init_flag=0;
unsigned int uart2_rec_error = 0;
unsigned int uart2_tra_error = 0;

static unsigned char	*p_uart2_tra;	       /* Transmit data address */
static unsigned char	*p_uart2_rec;	       /* Receive data address */


/*

    UART2 MM@ݒ֐

*/
void uart2_tra_rec_init(void)
{	
  init_buf2_tra();		  /* Initialize Transmit data */
  p_uart2_rec = &buf2_rec[0];     /* Initialize pointer */
  
  /* |[g֌W̐ݒ */
  pd7 |= 0x01;
  pd7 &= ~(0x02);

  /*NbN̐ݒ*/
  /*f1SIO𗘗p*/
  prc0 = 1;	/*veNg*/
  pclk1 = 1;	/*f1SIO𗘗p*/
  prc0 = 0;	/*veNg*/
  
  /*-------- UART2Ɗ荞݂̐ݒs ----------*/
  
  /* UART2 Transmit/Receive Mode Register */
  u2mr = 0x65;  /* 0110 0101  peBCXgbvrbgPCWrbg*/
  
  /* UART2 M䃌WX^iOj*/
  u2c0 = 0x10; /* CTS/TRSsȂD*/
  
  /* UART2 {[[g̐ݒ*/
  u2brg = UART2_BOWRATE;
  
  /* UART2䃌WX^i荞ݗvȂǁj*/
  u2c1 |= 0x10;
  u2c1 &= ~(0x20);
  
  /*Mobt@NA[ɂ*/
  u2rbl = 0x00;
  u2tb  = 0x00;
  
  /*UART2̑M荞ݐݒ  default:D惌x͂SD*/
  _asm("FCLR I");
  s2ric = 0x04;
  s2tic = 0x04;
  _asm("FSET I");
  
  /* UART2M䃌WX^iPj*/
  /* ̒iKł́CM͏oȂD*/
  u2c1 &= ~(0x0F);

  /*buffer̃TCY1AM\̐ݒ񐔂傫ꍇ*/
  if ( (TRA2_NUM < TRA2_SIZE) || (REC2_NUM < REC2_SIZE) ) 
  {
    if (TRA2_NUM < TRA2_SIZE) uart2_tra_error = UART_INIT_BUF_OVERFLOW;
    if (REC2_NUM < REC2_SIZE) uart2_rec_error = UART_INIT_BUF_OVERFLOW;
    return;
  }
  
  uart2_init_flag = 1;
}

/*

	MJn֐                                            

*/

/* UART2 transmit & receive function (Start) */
void uart2_tra_rec_st(void)
{
  /* Ƃ肠AMʒm| */
  uart2_received = 0;
  uart2_rec_error = 0;
  u2c1 &= ~(0x0F);
   
  /* MRg[tO */
  uart2_transmited =0;
  uart2_tra_error = 0;

  /* |C^̈ʒu擪ɂ */
  p_uart2_tra = &buf2_tra[0];
  p_uart2_rec = &buf2_rec[0];
  
  /* M */
  u2c1 |= 0x05;

  /* MJn */
  u2tb = *p_uart2_tra;/*  data Transmit */

  /* ^[~l[^̏ꍇC
     M̎_őM~邽߂̃tO */
  if ( *p_uart2_tra == UART2_TERMINATOR ) uart2_transmited = 1; 
  
  /*Mʒuɂ炷 */
  p_uart2_tra++;
  
}

void uart2_tra_st(void)
{
  /* Ƃ肠@M֎~ */
  u2c1 &= ~(0x01);
  
  uart2_transmited = 0;
  uart2_tra_error = 0;
  
  /*@|C^̈ʒu𑗐Mf[^̐擪ɂ */
  p_uart2_tra = &buf2_tra[0];
  
  /* M */
  u2c1 |= 0x01;	
  
  /* MJn */
  u2tb = *p_uart2_tra;
  
  /* ^[~l[^̏ꍇC
     M̎_őM~邽߂̃tO */
  if ( *p_uart2_tra == UART2_TERMINATOR ) uart2_transmited = 1;

  /*Mʒuɂ炷 */
  p_uart2_tra++;
  
}

void uart2_rec_st(void)
{
  /* Ƃ肠@M֎~ */
  u2c1 &= ~(0x04);
  
  uart2_received = 0;
  uart2_rec_error = 0;
  
  /* |C^̈ʒuMf[^擪ɂ */
  p_uart2_rec = &buf2_rec[0];
  
  /* M */
  u2c1 |= 0x04;
  
}

/*

 	Mf[^̏                                              

*/

void init_buf2_tra(void)
{
  unsigned char count;		/* Counter */
  p_uart2_tra = &buf2_tra[0];	/* Initialize pointer */
  for(count = 0; count < (sizeof buf2_tra / sizeof buf2_tra[0]); count++)
    {
      *p_uart2_tra = count;	/* Initialize Transmit data */
      p_uart2_tra++;		/* Pointer increment */
    }
  p_uart2_tra = &buf2_tra[0];	/* Initialize pointer */
}

/*

      UART M荞݊֐                                          	       

*/

void  uart2recint(void)
{
  /*----- buffer over flow̒ -----*/
  if(p_uart2_rec > &buf2_rec[REC2_NUM - 2] )
    {
      /* M~ */
      u2c1 &= ~(0x04);
      /* buffer over flow */
      uart2_rec_error = UART_BUF_OVERFLOW;
      /* |C^ʒuŏɖ߂ */
      p_uart2_rec = &buf2_rec[0];
      /* ꉞM */
      uart2_received = 1;
      return;
    }
  else
    {
      /* G[tOɖ߂ */
      uart2_rec_error = 0;
      /* MG[o */
      if (sum_u2rb == 1)
	{
	  /* received error */
	  uart2_rec_error = UART_REC_ERROR_CODE + ((u2rbh>>4)&0x07);
	  /* u2_rbh_4 = 1 : uart2 Overrun error */
	  /* u2_rbh_5 = 1 : uart2 Framing error */
	  /* u2_rbh_6 = 1 : uart2 Parity  error */
	  u2rbl;
	  
	  /*@M~ */
	  u2c1 &= ~(0x04);
	  
	  /*ꉞM*/
	  uart2_received = 1;
	  
	  return;
	}
      /* obt@ɎMe */
      *p_uart2_rec = u2rbl;
      /* ^[~l[^MAMI */
      if(*p_uart2_rec == UART2_TERMINATOR )
	{
	  /* M~ */
	  u2c1 &= ~(0x04);
	  /* I[A^[~l[^'\0'ɕύX */
	  *p_uart2_rec = '\0';
	  /* MƂʒm */
	  uart2_received = 1;
	  /* |C^ʒuŏɖ߂ */
	  p_uart2_rec = &buf2_rec[0];
	  
	  return;
	}
      /* |C^ɐi߂*/
      p_uart2_rec++;
    }
}

/*

    UART M荞݊֐ 

*/
void uart2traint(void)
{
  if( (p_uart2_tra > &buf2_tra[TRA2_NUM - 1]) || uart2_transmited )
    {
      u2c1 &= ~(0x01);	/* Stop Transmit */
      
      /*----- buffer over flow̒ -----*/
      if (p_uart2_tra > &buf2_tra[TRA2_NUM - 1]) uart2_tra_error = UART_BUF_OVERFLOW;
      
      /* Mobt@̑Mʒuŏɖ߂*/
      p_uart2_tra = &buf2_tra[0];
      
    }
  else
    {
      u2tb = *p_uart2_tra;    /* Transmit */
      /* ^[~l[^̑MA
	 ̑MI_őM~B*/
      if(*p_uart2_tra == UART2_TERMINATOR ) uart2_transmited=1;
      p_uart2_tra++;		/* Pointer increment */
    }
}
