/*----------------------------------------------------------------------
  RFID READ WRITE MODULE
  Control Library For C Language            v720s.c   ver 1.0 Release
   
  2006/10/20
  AUTHOR:Hyunjong Kim (Matsuo Lab.)   ADVISOR:YUGO MORITA (Matsuo Lab.) 

 -> Date : 2007/10/17 Renewal : Jumpei Nishizaki
 Cӂ̃y[WɏƂƃG[oOC

  ----------------------------------------------------------------------*/

//#include <stdio.h>
#include "v720s.h"
#include "uart2.h"
#include <string.h>
#include "nosprintf.h"

extern unsigned char uart2_init_flag;
extern unsigned char uart2_received;
extern unsigned char uart2_transmited;
extern unsigned char buf2_tra[];
extern unsigned char buf2_rec[];
extern unsigned int uart2_rec_error;

static unsigned int v720s_init_flag = 0;
static unsigned int v720s_rec_continue = 0;

unsigned int v720s_busy = 0;


/*
------------------------
  ֐
-------------------------
*/

int v720s_init()
{
  int check;
  
  /* ʐM̐ݒ */
  uart2_tra_rec_init();
  
  /* ʐM\ǂ̃`FbN@*/
  check = v720s_test();
  
  /*@ʐMeXgłȂ΁CG[ŕԂ@*/
  if(check != 0 ) return check;
  
  /* ς݂ł邱ƂtO𗧂Ă */
  v720s_init_flag = 1;
  
  return 0;
}

int v720s_test(void)
{
  long int count=0;
  /* TESTR}h𑗐M */
  strcpy(buf2_tra, "10\r");
  uart2_tra_rec_st();
  
  /* uart2_received flag ܂ő҂ */
  while(!uart2_received)
    {
      count++;
      if(count > 10000000) return 999; /*v720Ƃ̒ʐMłȂƔf*/
    }
  
  if (uart2_rec_error != 0) return uart2_rec_error; /*UART2̎MG[*/
  
  /* Mf[^A"00\r"ǂ`FbN */
  if(buf2_rec[0] == '0' && buf2_rec[1] == '0')
    {
      /* OK */
      return 0;
    }
  else{
    /* NG */
    return 998; /*TESTR}h̃X|XIR[hł͂Ȃ*/
  }
}

int v720s_putcmd_write(unsigned char _mode_type, unsigned char _bank_st, int _pagenum_fs_st, char _far *data)
{  
  int count;
  int pages = 0;
  int leftover = 0;
  int i;
  int pages_command;
  
  /* Ă邩ǂ`FbN */
  if(v720s_init_flag != 1) return 997;
  
  /* M[h̃`FbNiWRITER}hSINGLE REPEAT[hł͎ssj*/
  if ((_mode_type != V720S_MODE_ST) && 
      (_mode_type != V720S_MODE_SA) && 
      (_mode_type != V720S_MODE_FT) && 
      (_mode_type != V720S_MODE_FA) && 
      (_mode_type != V720S_MODE_FR))
    return 994;
  
  if (v720s_busy != 0) return 995; /*O̖߂̃X|XM*/
  
  /* (64 - ݏʒuy[W*4)ȓmF */
  for(count=0; count < ( 64 - 4*_pagenum_fs_st ); count++)
    {
      if( data[count] == '\0') break;
    }
  if( count >= 64) return 992;  /* Ȃ */
  
  /* Kvy[Wƒ[vZ*/
  pages = _pagenum_fs_st + count / 4 ;
  leftover = count % 4;
  
  /* [݂y[W͂Pw */
  /* leftover͑}󔒂̐ɍėp */
  if(leftover > 0 ){
    pages ++;
    leftover= 4 -leftover;
  }

  /* mۂy[Ww肷 */
  pages_command = ((1 << pages)-1)&(0xFFFF << _pagenum_fs_st);

  /* buf2_tra ɑMR}hAMIvVAoNws */
  strcpy(buf2_tra,"0000000000");
  exc_htoa(&buf2_tra[1],V720S_CMD_WRITE);
  exc_htoa(&buf2_tra[3],V720S_CONTACT_OPTION_ASCII(_mode_type) );
  exc_htoa(&buf2_tra[5],_bank_st);
  exc_htoa(&buf2_tra[9],pages_command);

  strcat(buf2_tra,data);
    
  /* Ȃ͋󔒂Ŗ߂ */
  for(i= 0 ; i < leftover ; i++)
    {
      strcat(buf2_tra, " ");
    }
  
  strcat(buf2_tra, CR_TERMINATOR);
  
  if (uart2_transmited != 1) return 996; /* O̖߂̑M*/
  
  /* ʊ֐ĂяoDMJn */
  uart2_tra_rec_st();
  
  /* AM̃`FbN */
  if (_mode_type == V720S_MODE_FR) v720s_rec_continue = 1;
  
  v720s_busy = 1;
  
  return 0;
}

int v720s_putcmd_read(unsigned char _mode_type, unsigned char _bank_st,int _pagenum_fs_st, int _pagenum_fs_end)
{

  //	unsigned char tmp[6]="";
  /* ʐM̏͂ȂĂ邩H */
  if (v720s_init_flag == 0 ) return 997;
  
  /* M[h̃`FbN */
  if ((_mode_type != V720S_MODE_ST) && 
      (_mode_type != V720S_MODE_SA) && 
      (_mode_type != V720S_MODE_SR) && 
      (_mode_type != V720S_MODE_FT) && 
      (_mode_type != V720S_MODE_FA) && 
      (_mode_type != V720S_MODE_FR))
    return 994;
  
  if (v720s_busy != 0) return 995; /*O̖߂̃X|XM*/

  //_pagenum_fs_st = 0;
  //_pagenum_fs_end = 0;

  /* t[Xy[X̃y[Ww̌*/
  if ( (_pagenum_fs_st > _pagenum_fs_end) || (_pagenum_fs_st < 0) || (_pagenum_fs_end > 15) ) return 991;

	_pagenum_fs_st = ((1 << _pagenum_fs_st)-1);
	strcpy(buf2_tra,"0000000000");
	exc_htoa(&buf2_tra[1],V720S_CMD_READ);
	exc_htoa(&buf2_tra[3],V720S_CONTACT_OPTION_ASCII(_mode_type) );
	exc_htoa(&buf2_tra[5],_bank_st);
	exc_htoa(&buf2_tra[9],V720S_GETPAGE_FS(_pagenum_fs_end+1)-_pagenum_fs_st);

  /* AM̃`FbN */
  if ((_mode_type == V720S_MODE_SR) || (_mode_type == V720S_MODE_FR)) v720s_rec_continue = 1;

  strcat(buf2_tra, CR_TERMINATOR); 
  uart2_tra_rec_st();
  v720s_busy = 1;

  return 0;
}

int v720s_putcmd_serial(unsigned char _mode_type)
{
  //	unsigned char tmp[6]="";
  /* ʐM̏͂ȂĂ邩H */
  if (v720s_init_flag == 0 ) return 997;
  
  /* M[h̃`FbN */
  if ((_mode_type != V720S_MODE_ST) && 
      (_mode_type != V720S_MODE_SA) && 
      (_mode_type != V720S_MODE_SR) && 
      (_mode_type != V720S_MODE_FT) && 
      (_mode_type != V720S_MODE_FA) && 
      (_mode_type != V720S_MODE_FR))
    return 994;
  
  if (v720s_busy != 0) return 995; /*O̖߂̃X|XM*/

      strcpy(buf2_tra,"0000");
      exc_htoa(&buf2_tra[1],V720S_CMD_READ_UID);
      exc_htoa(&buf2_tra[3],V720S_CONTACT_OPTION_HEX(_mode_type) );

  /* AM̃`FbN */
  if ((_mode_type == V720S_MODE_SR) || (_mode_type == V720S_MODE_FR)) v720s_rec_continue = 1;

  strcat(buf2_tra, CR_TERMINATOR); 
  uart2_tra_rec_st();
  v720s_busy = 1;

  return 0;

}

int v720s_getdata(char _far *data)
{
  int first,second;
  int length;
  int i;
  int uart2_error_copy;

  uart2_received = 0;
  v720s_busy = 0;
  
  if (uart2_rec_error != 0)
    {  
      if (v720s_rec_continue == 1) uart2_rec_st();
      return uart2_rec_error;
    }	
  
  /* M̒v */
  for(i = 0 ; i < 140 ; i++)
    {
      if(buf2_rec[i] == '\0') break;
    }
  
  /* M140ȏゾ */
  if(i >= 140 ) return 995;
  
  
  /* f[^zɊi[ */
  strcpy(data, &buf2_rec[2]);
  
  /* ŏ̓񕶎̃AXL[R[h𐔎ɒ */
  first = (int)(buf2_rec[0]) - (int)('0');
  second = (int)(buf2_rec[1]) - (int)('0');
  
  if (v720s_rec_continue == 1) uart2_rec_st();
  /* IR}hint^Ԃ */
  return (first*10 + second);
}

int v720s_putcmd_stop(void)
{
  
  /* Ă邩ǂ`FbN */
  if (v720s_init_flag == 0 ) return 997;

  /* AM̒~ */
  v720s_rec_continue = 0;
  
  /* STOPR}h̑M */
  //sprintf(buf2_tra, "%02X%c", V720S_CMD_STOP, CR_TERMINATOR);
  strcpy(buf2_tra,"13\r");
  
  if (uart2_transmited != 1) return 996; /* O̖߂̑M*/
  
  uart2_tra_rec_st();
  
  /* I */
  return 0;  
}
