/*
----------------------------------------------------------------------
  RFID READ WRITE MODULE
  Control Library For C Language             v720j.h    ver 1.0beta
   
  2006/10/20
  AUTHOR:Hyunjong Kim (Matsuo Lab.)   ADVISOR:YUGO MORITA (Matsuo Lab.) 

 -> Date : 2007/10/11 Renewal : Jumpei Nishizaki 			    

v720s.h CĔCӂ̃oNɑ΂ēǂݏ\
----------------------------------------------------------------------
*/

#ifndef __rfid_H__
#define __rfid_H__

#ifndef __V720S_H__
#define __V720S_H__

/* Command */
#define V720S_CMD_TEST                 0X10
#define V720S_CMD_STOP                 0X13
#define V720S_CMD_READ                 0X31
#define V720S_CMD_WRITE                0X32
#define V720S_CMD_READ_UID             0X35

#define V720S_DATA_UID           (unsigned char)0      /* Serial Number */
#define V720S_DATA_OT            (unsigned char)1      /* Occupied Territory */

/* Tag Type and Data Code */
#define V720S_TAGTYPE                  0X20    /* Tag Type: SL2-ICS20 */
#define V720S_DATACODE_ASCII           0X10    /* Data Code: ASCII */
#define V720S_DATACODE_HEX             0X00    /* Data Code: HEX */

/* Library Function Argument (Contact Mode Type) */
#define V720S_MODE_ST            (unsigned char)0X00   /* Single Trigger */
#define V720S_MODE_SA            (unsigned char)0X01   /* Single Auto */

#define V720S_MODE_SR            (unsigned char)0X02   /* Single Repeat
						      (READ command only) */

#define V720S_MODE_FT            (unsigned char)0X08   /* FIFO Trigger */
#define V720S_MODE_FA            (unsigned char)0X09   /* FIFO AUTO */
#define V720S_MODE_FR            (unsigned char)0X0B   /* FIFO_REPEAT */

#define V720S_PAGE_FS_MIN              0X0001  /* freespace starting page */

#define V720S_CONTACT_OPTION_ASCII(MODE)  (V720S_TAGTYPE | V720S_DATACODE_ASCII | MODE)
#define V720S_CONTACT_OPTION_HEX(MODE)    (V720S_TAGTYPE | V720S_DATACODE_HEX | MODE)

#define V720S_GETPAGE_FS(PAGENUM_FS)     ((V720S_PAGE_FS_MIN << PAGENUM_FS) - V720S_PAGE_FS_MIN)

#define CR_TERMINATOR	          "\r"

#endif

/*  */
int v720s_init(void);
/* ʐMeXgs (tO̊mFsĂȂ̂ňɒ)*/
int v720s_test(void);
/* f[^ǂݏo*/
int v720s_getdata(char _far *);
/* w肵oNEy[WɃf[^ޗvo */
int v720s_putcmd_write(unsigned char, unsigned char, int, char _far *);
/* w肵oNEy[W̃f[^ǂޗvo */
int v720s_putcmd_read(unsigned char, unsigned char, int,int);
/* ^ÕVAio[ǂޗvo */
int v720s_putcmd_serial(unsigned char);
/*^O̔M~CRepeat[h̉*/
int v720s_putcmd_stop(void);
#endif
